// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// findpost.cpp
// find a post by ID.
// 12.09.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

###POSTLIST_PATH

#include <stdio.h>

int main(int argc, char *argv[])
{
	unsigned long to_find;
	unsigned long postnumber;
	unsigned long pagenumber=0;
	unsigned long pagenumber2;
	char path[256];
	char text[256];
	FILE *file;
	
	if (argc<2)
	{
		printf("0\n");
		return 0;
	}
	sscanf(argv[1],"%lu",&to_find);
	
	for(short i=31;i>=0;--i)
	{
		pagenumber2 = pagenumber + (1L << i);
		sprintf(path,"%s%lu",POSTLIST_PATH,pagenumber2);
		file=fopen(path,"rt");
		if(file==NULL)
			continue;
		fgets(text,255,file);
		fclose(file);
		sscanf(text,"%lu",&postnumber);
		if(postnumber==to_find)
		{
			printf("%lu\n",pagenumber2);
			return pagenumber2;
		}
		else if(postnumber<to_find)
			pagenumber=pagenumber2;
	}
	if(pagenumber==0)
	{
		printf("0\n");
		return 0;
	}
	sprintf(path,"%s%lu",POSTLIST_PATH,pagenumber);
	file=fopen(path,"rt");
	if(file==NULL)
	{
		printf("0\n");
		return 0;
	}
	while(fgets(text,255,file)!=NULL ) 
	{
		sscanf(text,"%lu",&postnumber);
		if(postnumber==to_find)
		{
			fclose(file);
			printf("%lu\n",pagenumber);
			return pagenumber;
		}
	}
	fclose(file);
	sprintf(path,"%s%lu",POSTLIST_PATH,pagenumber-1);
	file=fopen(path,"rt");
	if(file==NULL)
	{
		printf("0\n");
		return 0;
	}
	while(fgets(text,255,file)!=NULL ) 
	{
		sscanf(text,"%lu",&postnumber);
		if(postnumber==to_find)
		{
			fclose(file);
			printf("%lu\n",pagenumber-1);
			return pagenumber-1;
		}
		// else if(postnumber>to_find)
		// {
			// fclose(file);
			// printf("0\n");
			// return 0;
		// }
	}
	printf("0\n");
	fclose(file);
	return 0;
}