# OTT mirror
# Copyright (C) 2014 Balthasar Szczepański
# upload.awk
# separate userinfo, signatures and content from page and upload it.
# 12.09.2014

# This file is part of OTT mirror.
#
# OTT mirror is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affreo General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# OTT mirror is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affreo General Public License for more details.
# 
# You should have received a copy of the GNU Affreo General Public License
# along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

BEGIN{
#parametrse:
#outfile
#otterinf/
#sig/
	sig2=""
	otterinf2=""
#	print(outfile " " sig " " otterinf)
	printf("%s","") > outfile
	where=0
#0 - nphead
#1 - content
#2 - c(post)
#3 - c(postcontent)
#4 - c(sig)
#5 - c(info)
#6 - END

};
{
	if((where==6) && ($0 == "</div>"))
	{
		exit
	}
	
	if(($0 ~ /<div class=.pagination./)&&(where==1))
	{
		where=6
	}
	
	if(($0 ~ /<div class=.pagination./)&&(where==0))
	{
		where=1
	}
	
	if($0 ~ /<div id=.p[0-9]/)
	{
		where=2
	}
	
	if((where==2) && ($0 ~ /<p class=.author./))
	{
		for (i=1;i<=NF;++i)
		{
			if ($i ~ /viewprofile.*u=/)
			{
				split($i, arr,"u=|\"")
				for(j=1;j in arr;++j)
				{
					if (arr[j] ~ /^[0-9]*$/)
					{
						uid=arr[j]
						sig2=(sig uid)
						otterinf2=(otterinf uid)
						break
					}
				}
				
				break
			}
		}
	}
	
	if(($0 ~ /<div class=.content./)&&(where=2))
	{
		where=3
	}
	
	if($0 ~ /<div id=.sig[0-9]/)
	{
		where=4
		print ("###sig&" uid) >> outfile 
		printf ("%s","") > sig2
	}
	
	if($0 ~ /<dl class=.postprofile/)
	{
		where=5
		print ("###inf&" uid) >> outfile
		printf ("%s","") > otterinf2
	}
	
	if($0 ~ /<hr class=.divider/)
	{
		where=1
		close(sig2)
		close(otterinf2)
	}
	
	if((where==2)||(where==3)||($0 ~ /<hr class=.divider/))
	{
		print $0 >> outfile
	}
	
	if(where==4)
	{
		print $0 >> sig2
	}
	
	if(where==5)
	{
		print $0 >> otterinf2
	}
};